<template>
  <div id="notification">
    <div>
      <keep-alive>
        <svg v-show="showRedDot" id="alertCircle" xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-circle-fill" viewBox="0 0 16 16">
            <circle cx="8" cy="8" r="8"/>
        </svg>
      </keep-alive>
  </div>
    <button @click="openNotification" id="notificationBtn">
      <svg id="chatIcon" xmlns="http://www.w3.org/2000/svg" width="32" height="32" fill="currentColor" class="bi bi-chat-square-quote-fill" viewBox="0 0 16 16">
        <path d="M0 2a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v8a2 2 0 0 1-2 2h-2.5a1 1 0 0 0-.8.4l-1.9 2.533a1 1 0 0 1-1.6 0L5.3 12.4a1 1 0 0 0-.8-.4H2a2 2 0 0 1-2-2V2zm7.194 2.766a1.688 1.688 0 0 0-.227-.272 1.467 1.467 0 0 0-.469-.324l-.008-.004A1.785 1.785 0 0 0 5.734 4C4.776 4 4 4.746 4 5.667c0 .92.776 1.666 1.734 1.666.343 0 .662-.095.931-.26-.137.389-.39.804-.81 1.22a.405.405 0 0 0 .011.59c.173.16.447.155.614-.01 1.334-1.329 1.37-2.758.941-3.706a2.461 2.461 0 0 0-.227-.4zM11 7.073c-.136.389-.39.804-.81 1.22a.405.405 0 0 0 .012.59c.172.16.446.155.613-.01 1.334-1.329 1.37-2.758.942-3.706a2.466 2.466 0 0 0-.228-.4 1.686 1.686 0 0 0-.227-.273 1.466 1.466 0 0 0-.469-.324l-.008-.004A1.785 1.785 0 0 0 10.07 4c-.957 0-1.734.746-1.734 1.667 0 .92.777 1.666 1.734 1.666.343 0 .662-.095.931-.26z"/>
      </svg>
    </button>
  </div>
  <ModalWindow v-if="showMessage" @close="showMessage = false"
               :title="title"
               :body="body" />
</template>

<script>
import ModalWindow from "./ModalWindow";
import { mapState } from 'vuex'

export default {
  name: "Notification",
  components: {
    ModalWindow
  },
  data() {
    return {
      title: "Notification",
      message: null,
      body: null,
      showRedDot: false,
      showMessage: false
    }
  },
  computed: mapState(['sse']),
  watch: {
    // Check for sse
    sse(new_value) {
      if (new_value !== undefined) {
        this.toggleDot(); // Show red dot if there is an sse
        this.message = new_value.msg; // Assign message to sse msg
      }
    }
  },
  methods: {
    openNotification() {
      // Allow opening of notification window if there is an sse
      if (this.showRedDot === true) {
        this.body = this.message;
        this.showMessage = true;
        this.showRedDot = false;
      }
    },
    toggleDot() {
      this.showRedDot = true;
    }
  }
}
</script>

<style scoped>
svg {
  color: #886565;
}

svg:hover {
  color: #ead8c4;
}

#alertCircle {
  z-index: 15;
  bottom: 4.5rem;
  right: 4.5rem;
  position: fixed;
  color: #e35b6b;
  stroke: #ead8c4;
}

#notification {
  display: block;
  position: fixed;
  padding: 1.1rem 0.6rem;
  z-index: 11;
  bottom: 2rem;
  right: 2rem;
  max-width: 4rem;
  max-height: 4rem;
  margin: auto;
  border-radius: 50%;
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
  background-color: #ead8c4;
  color: #6e5252;
  pointer-events: all;
}

#notification:hover{
  background-color: #584141;
}

#notificationBtn {
  border: transparent;
  background-color: transparent;
}
</style>